<!doctype html>
<html class="stickyfooter" lang="en">
<head>
<meta charset="utf-8" />
<title><%= htmlWebpackPlugin.options.title %></title>
<meta name="author" content="nw520" />
<meta name="viewport" content="width=device-width,initial-scale=1,shrink-to-fit=no" />
<link rel="stylesheet" href="css/bootstrap.min.css" />
<link rel="stylesheet" href="css/bootstrap-select.min.css" />
<link rel="stylesheet" href="css/style.css" />
</head>

<body>
<div id="content">
	<nav class="bg-dark navbar navbar-dark navbar-expand-lg">
		<div class="container-fluid">
			<a class="navbar-brand" href="#"><%= htmlWebpackPlugin.options.title %></a>
			<button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarToggler" aria-controls="navbarToggler" aria-expanded="false" aria-label="Toggle navigation">
				<span class="navbar-toggler-icon"></span>
			</button>
			<div class="collapse navbar-collapse" id="navbarToggler">
				<ul class="nav navbar-nav">
					<li class="nav-item dropdown">
						<a class="nav-link dropdown-toggle" href="#" id="navitem-tools" role="button" data-bs-toggle="dropdown" aria-haspopup="true" aria-expanded="false">More Wikidata tools</a>
						<div class="dropdown-menu" aria-labelledby="navitem-tools">
							<a class="dropdown-item" href="https://muekoeff.gitlab.io/entitycompare/" rel="noopener">EntityCompare</a>
							<a class="dropdown-item" href="https://muekoeff.github.io/wikiosmerged/" rel="noopener">WikiOSMerged</a>
						</div>
					</li>
					<li class="nav-item">
						<a class="nav-link" href="https://quickstatements.toolforge.org/#/batch" rel="noopener">QuickStatements</a>
					</li>
					<li class="nav-item">
						<a class="nav-link" href="#" data-bs-toggle="modal" data-bs-target="#modal-settings">Settings</a>
					</li>
					<li class="nav-item">
						<a class="nav-link" href="#" data-bs-toggle="modal" data-bs-target="#modal-help">Help</a>
					</li>
				</ul>
			</div>
		</div>
	</nav>
	<main class="container-fluid py-5">
		<div id="error-messages" class="alert alert-danger row pmargin-fix" v-if="Object.keys( errors ).length > 0">
			<div v-for="( error, group ) in errors">
				<strong>{{error[ 0 ]}}</strong> {{error[ 1 ]}}
			</div>
		</div>
		<div>
			<textarea id="commands" class="form-control" rows="10" v-bind:placeholder="example" v-model="input"></textarea>
		</div>
		<br />
		<div class="d-flex align-items-center">
			<button id="button-parse" class="btn btn-primary" v-bind:disabled="input.length === 0" v-if="settings.splitParseResolve" v-on:click.prevent="parseInput">Parse</button>
			<div class="btn-group" v-if="settings.splitParseResolve">
				<button id="button-resolve" class="btn btn-primary ms-1" v-bind:disabled="commandLines.length === 0" v-on:click.prevent="resolveTuples">Resolve all</button>
				<button id="button-resolve" class="btn btn-primary ms-1" v-bind:disabled="commandLines.length === 0" v-if="commandLines.length > 0" v-on:click.prevent="resolvePendingTuples">Resolve all</button>
			</div>
			<div class="btn-group" v-if="!settings.splitParseResolve">
				<button id="button-parse-resolve" class="btn btn-primary" v-bind:disabled="input.length === 0" v-on:click.prevent="parseAndResolve">Resolve all</button>
				<button id="button-parse-resolve" class="btn btn-primary" v-bind:disabled="input.length === 0" v-if="commandLines.length > 0" v-on:click.prevent="resolvePendingTuples">Resolve pending</button>
			</div>
			<div class="align-items-center d-flex flex-grow-1 mx-4">
				<p class="m-0">No idea what to to? Click <a href="#" data-bs-toggle="modal" data-bs-target="#modal-help">here</a> to read the help. Or hit that "Use example"-button to the right.</p>
			</div>
			<button id="button-useexample" class="btn btn-secondary" href="#" v-bind:disabled="example === input" v-on:click.prevent="exampleUse">Use example</button>
			<button id="button-settings" class="btn btn-secondary ms-1" href="#" title="Open settings" data-bs-toggle="modal" data-bs-target="#modal-settings">⚙️</button>
		</div>
		<div class="d-flex mt-5">
			<h3 class="flex-grow-1">Data</h3>
			<div>
				<select id="statusfilter" class="selectpicker v-selectpicker" multiple title="Filter results by status" data-actions-box="true" v-model="filterStatus">
					<option data-content="<span class='option-status option-status-pending'>Pending</span>" value="pending" selected>Pending</option>
					<option data-content="<span class='option-status option-status-disambiguation'>Disambiguation</span>" value="disambiguation" selected>Disambiguation</option>
					<option data-content="<span class='option-status option-status-no-results'>No results</span>" value="no results" selected>No results</option>
					<option data-content="<span class='option-status option-status-success'>Success</span>" value="success" selected>Success</option>
					<option data-content="<span class='option-status option-status-failed'>Failed</span>" value="failed" selected>Failed</option>
					<option data-content="<span class='option-status option-status-removed'>Removed</span>" value="removed">Removed</option>
				</select>
			</div>
		</div>
		<div>
			<div id="progressbar" class="progress" v-bind:class="{ 'progress-grouped': settings.groupProgressbarStatus }">
				<template v-for="( commandLine, lineNo ) in commandLines">
					<template v-for="tuple in filterTuple( commandLine )">
						<div v-bind:class="'progress-bar status-' + tuple.status.replace( / /g, '-' )" role="progressbar" v-if="!settings.filterProgressbar || filterStatus.includes( tuple.status ) || tuple.status === 'working'"></div>
					</template>
				</template>
			</div>
		</div>
		<div>
			<table id="table-output" class="table table-tbody-hover table-tbody-striped" role="grid">
				<thead>
					<tr role="row">
						<th scope="col">Line</th>
						<th scope="col">Status</th>
						<th scope="col">Search query</th>
						<th scope="col">Result</th>
						<th scope="col">Disambiguation</th>
						<th scope="col">&nbsp;</th>
					</tr>
				</thead>
				<tbody v-if="commandLines.length === 0">
					<tr>
						<td colspan="6">No data</td>
					</tr>
				</tbody>
				<template v-for="(commandLine, lineNo) in commandLines">
					<template v-for="(tuple, tupleNo) in commandLine">
						<tuple-row v-bind:commandline="commandLine" v-bind:displaycommandline="settings.displayCommandLine" v-bind:lineindex="lineNo" v-bind:tuple="tuple" v-bind:tupleindex="lineNo" v-if="filterStatus.includes( tuple.status ) || tuple.status === 'working'" />
					</template>
				</template>
			</table>
		</div>
		<div>
			<button id="button-output" class="btn btn-primary" v-bind:disabled="commandLines.length === 0" v-on:click.prevent="generateOutput">Generate output</button>&nbsp;
		</div>
		<div class="align-items-center d-flex mt-5">
			<h3 class="flex-grow-1">Result</h3>
			<p class="m-0 me-2" title="All output is redirected to another application" v-if="output.pipeEnabled">🚇 Piping is enabled</p>
			<div class="btn-group" role="group">
				<button id="button-result-tools" type="button" class="btn btn-outline-secondary dropdown-toggle" data-bs-toggle="dropdown" aria-haspopup="true" aria-expanded="false" v-bind:disabled="output.success === null">Tools</button>
				<ul class="dropdown-menu" aria-labelledby="button-result-tools">
					<li><button id="button-copyquickstatements" class="dropdown-item" type="button" v-bind:disabled="output.success === null" v-on:click.prevent="copyQuickStatements">Copy &amp; open QuickStatements</button></li>
					<li><hr class="dropdown-divider" v-if="isEntityList"></li>
					<li><a id="button-entitycompare" class="dropdown-item" v-bind:href="entityCompareUrl" v-if="isEntityList">Open in EntityCompare</a></li>
				</ul>
				<button id="button-copy" class="btn btn-default btn-secondary" v-bind:disabled="output.success === null" v-on:click.prevent="copy">📋 Copy</button>
			</div>
		</div>
		<div>
			<textarea id="output" class="form-control" readonly rows="5" v-model="output.success"></textarea>
		</div>
		<div class="align-items-center d-flex mt-5">
			<h3 class="flex-grow-1">Failed</h3>
			<div class="btn-group" role="group">
				<button id="button-failed-tools" type="button" class="btn btn-outline-secondary dropdown-toggle" data-bs-toggle="dropdown" aria-haspopup="true" aria-expanded="false" v-bind:disabled="output.failed === null">Tools</button>
				<ul class="dropdown-menu" aria-labelledby="button-result-tools">
					<li><a id="button-failedToInput" class="dropdown-item" href="#commands" v-if="output.failed !== null" v-on:click="failedToInput">Copy failed to input</button></a>
				</ul>
				<button id="button-copy" class="btn btn-default btn-secondary" v-bind:disabled="output.failed === null" v-on:click.prevent="copyFailed">📋 Copy</button>
			</div>
		</div>
		<div>
			<textarea id="output-failed" class="form-control" readonly rows="1" v-model="output.failed"></textarea>
		</div>
	</main>
	<footer class="footer pb-5">
		<div class="container text-end">
			<span class="text-muted">
				Tool made by <a href="https://muekev.de/" target="_blank" rel="noopener">nw520</a> <small>(<a href="https://www.wikidata.org/wiki/User:Nw520" target="_blank" rel="noopener">@ Wikidata</a>)</small>.<br/>
				Thanks to <a href="https://www.wikidata.org/wiki/User:Tagishsimon" target="_blank" rel="noopener">Tagishsimon</a> for providing me with a <a href="https://www.wikidata.org/wiki/Wikidata:Request_a_query/Archive/2018/05#Check_whether_a_given_list_of_element_IDs_fullfills_certain_criteria_and_return_list_of_matching_items" target="_blank" rel="noopener">SPARQL query</a>.<br/>
				<a href="https://gitlab.com/muekoeff/rsolver/" target="_blank" rel="noopener">Source code @ GitLab</a> &bull; <a href="https://gitlab.com/muekoeff/rsolver/issues" target="_blank" rel="noopener">Report bugs @ GitLab</a>
			</span>
		</div>
	</footer>

	<%= require('./partials/modal-help.ejs')() %>
	<%= require('./partials/modal-grammar.ejs')() %>
	<%= require('./partials/modal-settings.ejs')() %>
</div>
<script src="js/jquery.min.js"></script>
<script src="js/popper.min.js"></script>
<script src="js/bootstrap.min.js"></script>
<script src="js/bootstrap-select.min.js"></script>
<script src="js/vue.global.prod.js"></script>
</body>
</html>
